/* GCNcrypt - Gamecube AR Crypto Program
 *
 * Copyright notice for this file:
 *  Copyright (C) 2003-2004 Parasyte
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#ifndef _DECRYPT_H_
#define _DECRYPT_H_


#include "types.h"

extern u16 gameid;
extern u8 dogameid,region;

extern u32 genseeds[0x20];
extern u8 bitstringlen[0x08];
extern u32 table0[0x40];
extern u32 table1[0x40];
extern u32 table2[0x40];
extern u32 table3[0x40];
extern u32 table4[0x40];
extern u32 table5[0x40];
extern u32 table6[0x40];
extern u32 table7[0x40];

void unscramble1(u32 *addr, u32 *val);
void unscramble2(u32 *addr, u32 *val);
void decryptcode(u32 *seeds, u32 *code);
u8 getbitstring(u32 *ctrl, u32 *out, u8 len);
u8 batchdecrypt(u32 *codes, u16 size);

#endif //_DECRYPT_H_
